/* This code sends out three consecutive 8 bit bytes to the 
 *  Occupancy LED panel.  The bytes are labeled Low, Medium and High.
 *  The order: first bit out is the LSB of the Low byte, and so on, 
 *  to the MSB of the High byte being the last bit out. Ergo: LSB first.
 *  The bytes received from the Occupancy detection hardware should foll
 *  the same pattern.
 */
  int i = 0;
  byte dataWordLow = 171;
  byte dataWordMedium = 226;
  byte dataWordHigh = 157;
  int A = 7;
  int B = 8;
  int Clk = 9;
  int Latch = 10;
  int SerialOut = 11; 
void setup() {
  // put your setup code here, to run once:
  Serial.begin(9600);
  Serial.println(".......Occupancy_LEDs_01...........................");
  for (int i=A; i<=SerialOut; i++){
  pinMode(i, OUTPUT);
  }
  digitalWrite(A,HIGH);
  digitalWrite(B,HIGH);
  digitalWrite(Clk,LOW);
  digitalWrite(Latch,LOW);
  digitalWrite(SerialOut,LOW);
}
void loop() {
  // put your main code here, to run repeatedly:
  delayMicroseconds(10); 
  digitalWrite(A,LOW);
  digitalWrite(B,LOW);
  delayMicroseconds(10); 
  sendOut( dataWordLow );
  sendOut( dataWordMedium );
  sendOut( dataWordHigh );
  latchIt();
  digitalWrite(A,HIGH);
  digitalWrite(B,HIGH);
  delay(10);
}
// Routine to clock the data in each bit...
void clockIt(){
    delayMicroseconds(5);
    digitalWrite(Clk,HIGH);
    delayMicroseconds(5);
    digitalWrite(Clk,LOW);
    delayMicroseconds(5);
}  
// Routine to latch the data after all shifted in...
void latchIt(){
  delayMicroseconds(5);
  digitalWrite(Latch,HIGH);
  delayMicroseconds(5);
  digitalWrite(Latch,LOW);
  delayMicroseconds(5);
}  
void sendOut( byte whichByte )
{
    for (byte i=0; i<=7; i++) {
    digitalWrite(SerialOut,(whichByte & (1 << i )));
    clockIt();
   }
}
 
