/* This code receives three consecutive 8 bit bytes from the 
 *  Occupancy Status panel.  The bytes are labeled Low, Medium and High.
 *  The order: first bit In is the LSB of the Low byte, and so on, 
 *  to the MSB of the High byte being the last bit in. Ergo: LSB first.
 *  The bytes sent to the Occupancy LEDs hardware should follow
 *  the same pattern.
 */
  int i = 0;
  unsigned long finalWord = 0;
  byte dataWordLow = 0;
  byte dataWordMedium = 0;
  byte dataWordHigh = 0;
  int A = 7;
  int B = 8;
  int Clk = 9;
  int Latch = 10;
  int SerialIn = 11; 
  byte numberLoops = 0;
void setup() {
  // put your setup code here, to run once:
  Serial.begin(9600);
  Serial.println(".......Occupancy_Status_01...........................");
  for (int i=A; i<=Latch; i++){
  pinMode(i, OUTPUT);
  }
  pinMode(SerialIn, INPUT); //We are shifting IN here.
  digitalWrite(A,HIGH);
  digitalWrite(B,HIGH);
  digitalWrite(Clk,LOW);
  digitalWrite(Latch,HIGH); //High to SHIFT, Low to LATCH.
 }
void loop() {
  // put your main code here, to run repeatedly:
  delayMicroseconds(10); 
  digitalWrite(A,LOW); // just for testing purposes.
  digitalWrite(B,LOW);
//....................................................
  changeChannel(2);
  latchIt();  // latch data into the shift registers.
  delayMicroseconds(10); 
  dataWordLow = shiftInByte();
   delay(10);
  dataWordMedium = shiftInByte();
  delay(10);
  dataWordHigh = shiftInByte();
  delay(10);
  finalWord = ( dataWordMedium + ( dataWordHigh * 256 ));
  finalWord = ( finalWord * 256 ) + dataWordLow;
/*  Serial.print( "Low = "); Serial.println( dataWordLow, HEX );
  Serial.print( "Mid = "); Serial.println( dataWordMedium, HEX );
  Serial.print( "High = "); Serial.println( dataWordHigh, HEX );
  Serial.println("..................................");
  Serial.print( "Final = "); Serial.println( finalWord, HEX);
  Serial.print( "Final = "); Serial.println( finalWord, BIN);
  Serial.println(".................................."); 
  numberLoops += 1;
  if (numberLoops > 5 ) delay(5000); */
}
//...................................................
// Routine to clock the data in each bit...
void clockIt(){
    delayMicroseconds(5);
    digitalWrite(Clk,HIGH);
    delayMicroseconds(5);
    digitalWrite(Clk,LOW);
    delayMicroseconds(5);
}  
// Routine to latch the data after all shifted in...
void latchIt(){
  delayMicroseconds(5);
  digitalWrite(Latch,LOW);
  clockIt();  // we need to clock while Latch is LOW to parallel load registers.
  digitalWrite(Latch,HIGH);
  delayMicroseconds(5);
}  
//.............................................................
// This routine shifts 8 bits IN from OCC detectors.
byte shiftInByte() 
{
  byte dataRead = 0;
  byte  temp = 0;
  delayMicroseconds(10);
  //now, use as many clocks as this channel needs
  for (int i = 7; i >=0; i--)
  {
    temp = digitalRead(SerialIn);
    temp = !temp; // added to have sent data same as received?
    temp = ( temp << i );
    dataRead = dataRead | temp;
    clockIt(); 
  }
  delayMicroseconds(10);
//  Serial.println(dataRead, HEX);
  return dataRead;
} // End shift IN 8 bits.
//.............................................................
void changeChannel( byte whichChannel)
 {
switch (whichChannel) {
    case 0:     //channel_A
        digitalWrite(A,LOW);
        digitalWrite(B,LOW);
      break;
    case 1:     //channel_B
        digitalWrite(A,HIGH);
        digitalWrite(B,LOW);
      break;
    case 2:     //channel_C
        digitalWrite(A,LOW);
        digitalWrite(B,HIGH);
      break;
    case 3:     //channel_D
        digitalWrite(A,HIGH);
        digitalWrite(B,HIGH);
      break;
    default: 
      // if nothing else matches, do the default: set to channel_B, OUTBOUND!
        digitalWrite(A,HIGH);
        digitalWrite(B,LOW);
    break;
  }
 }

